<template>
    <div id="communicator">
        <FriendsList :friends="friends" :selected-friend="selectedFriend" @change-friend="changeFriend" />
        <Talker :selected-friend="selectedFriend" @sender="addSenderIfNotExist" />
    </div>
</template>
  
<script setup lang="ts">
import { ref, Ref, onMounted } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import axios from 'axios';
import { useStore } from '../stores';
import { storeToRefs } from 'pinia';;

import useEmitter from '../composables/useEmitter';

import FriendsList from '../components/FriendsList.vue';
import Talker from '../components/Talker.vue';

const route = useRoute();
const router = useRouter();
const store = useStore();
const emitter = useEmitter();
const { user } = storeToRefs(store);
const { author } = route.params;

const selectedFriend: Ref<null | String> = ref(null);
const friends: Ref<String[]> = ref([]);

if (typeof author !== 'undefined') {
    selectedFriend.value = author as String;
}


axios
    // @ts-ignore  
    .post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/friend`, {
        uuid: user.value.uuid,
    })
    .then(({ data }) => {
        friends.value = data;
    })
    .catch((err) => {
        console.error(err);
    });



onMounted(async () => {
    await axios
    // @ts-ignore  
    .post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/message/get`, {
        uuid: user.value.uuid,
    })
    .then(({ data }) => {
        console.log(data);
        const messages = {};
        data.forEach((el) => {
            if (typeof messages[el[2]] === 'undefined') {
                messages[el[2]] = [];
            }
            messages[el[2]].push({
                content: el[0],
                created: el[1],
                sender: el[3] === 'FROM' ? el[2] : store.user.email,
            });
        });
        
        store.setMessages(messages);
        emitter.emit('messages-loaded')
    })
    .catch((err) => {
        console.error(err);
    });

    if (typeof user.value.uuid === 'undefined') {
        router.push('/');
    }
    // store.connect();
});

function changeFriend(data) {
    selectedFriend.value = data;
}

function addSenderIfNotExist(sender) {
    if (friends.value.indexOf(sender) < 0) {
        friends.value.push(sender);
    }
}
</script>
  
<style scoped lang="scss">
#communicator {
    margin: 20px;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
}
</style>
  